/*

Name:
	cnv_time

Function:
	Convert the time from the Unix "time" system call format
	to date and time string. Convert ":" to "|" to avoid
	pseudo-field definition for Tabstar.

Algorithm:
	Convert the time. Now convert all ":" to "|" and return pointer
	to new string.

Parameters:
	tvec[2] from system time call

Returns:
	Pointer to converted time string
	ENOERR	Normal exit

Files and Programs:
	None


*/
#include <stdio.h>


char *cnv_time(tvec)
int  tvec[2];
{
	static char id[] = "%W% %H%";
	char *bufp;
	char *save;
	int index;
	extern char *ctime();

	bufp = ctime(tvec);
	save = bufp;
	for (index = 0; index < 26; index++)
		switch (*bufp)        {
			case ':':
				*bufp++ = '|';
				break;
			case '\n':
				*bufp++ = '\0';
				break;
			default:
				bufp++;
				break;
		}
	return(bufp = save);
}
